import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * These move methods were copied from the different tutorials and beginner scenarios made by Michael Kollings
 * 
 * @author (Stephen Clement) 
 * @version (1.1)
 */
public class MovingUnit extends Actor
{
    public int bullet_speed = 17;
    public int moving_speed = 5;


     public void moveUp()
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX());
        int y = (int) Math.round(getY() - moving_speed);
        
        setLocation(x, y);
    }
    
         public void moveDown()
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX());
        int y = (int) Math.round(getY() + moving_speed);
        
        setLocation(x, y);
    }
    
    
         public void moveLeft()
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() - moving_speed);
        int y = (int) Math.round(getY());
        
        setLocation(x, y);
    }
    
    
             public void moveRight()
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + moving_speed);
        int y = (int) Math.round(getY());
        
        setLocation(x, y);
    }
    
    
        public void move()
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * bullet_speed);
        int y = (int) Math.round(getY() + Math.sin(angle) * bullet_speed);
        
        setLocation(x, y);
    }
    
    
     public void moveInvert()
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() - Math.cos(angle) * bullet_speed);
        int y = (int) Math.round(getY() + Math.sin(angle) * bullet_speed);
        
        setLocation(x, y);
    }
     public boolean atWorldEdge()
    {
        if(getX() < 2 || getX() > getWorld().getWidth() - 2)
            return true;
        if(getY() < 2 || getY() > getWorld().getHeight() - 2)
            return true;
        else
            return false;
    }
      public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0,0, clss);
        return actor != null;        
    }
    public void eat(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        if(actor != null) {
            getWorld().removeObject(actor);
        }
    }
}
