import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The world in which all the awsome paintball action takes place
 * 
 * @author Stephen Clement 
 * @version 1.1
 */
public class StephenWorld extends World
{
    public int r = 0;
    public int r2 = 0;
    public int w = 0;
    public int w2 = 0;
    private int x = 0;
    private int y = 0;
    private int times = 0;
    public int map;
    
    Soldier P1 = new Soldier();
    Soldier P2 = new Soldier();
    
    score_counter blue = new score_counter("");
    score_counter red = new score_counter("");
    
    public void act(){
        P1.setTeam(1);
        P2.setTeam(2);
    }
    
    text text = new text("Select Map", "Color.WHITE");
    /**
     * Constructor for objects of class StephenWorld.
     * 
     */
    public StephenWorld()
    {    
        super(750, 600, 1);
        setBackground("sand.PNG");
        mapMenu();
        setPaintOrder(score_counter.class,text.class,time_keeper.class,black.class,Splat.class,Soldier.class,sandbag.class,Paintball.class, menubutton.class,gun.class);
        Greenfoot.startSimulation();
    }
    
    public void mapMenu(){
        clearAll();
        addObject(new menu(getWidth(),getHeight()), getWidth()/2, getHeight()/2);
        addObject(text, 375, 100);
        addObject(new map1(), 550, 300);
        addObject(new map2(), 200, 300);
    }
    
    public void addSoldier(Soldier P){
        boolean flag = true;
        int times = 0;
        while(flag){
            int x = Greenfoot.getRandomNumber(this.getWidth()-60)+30;
            int y = Greenfoot.getRandomNumber(this.getHeight()-60)+30;
            if(getObjectsAt( x, y, sandbag.class).size() == 0&&getObjectsAt( x, y, black.class).size() == 0){
                addObject(P, x, y);
                flag = false;
            }
            if(times == 30){
                flag = false;
            }
            times++;
        }
    }
    
    public void addSoldier(Soldier P, int x, int y){
        addObject(P, x, y);
    }
    
    public void map1(){
        clearAll();
        map = 1;
        this.addSoldier(P1,100,150);
        this.addSoldier(P2,650,350);
        addObject(new sandbag(),200,30);
        addObject(new sandbag(),200,90);
        addObject(new sandbag(),200,150);
        addObject(new sandbag(),200,210);
        addObject(new sandbag(),200,270);
        addObject(new sandbag(),150,270);
        addObject(new sandbag(),375,210);
        addObject(new sandbag(),375,270);
        addObject(new sandbag(),375,330);
        addObject(new sandbag(),375,150);
        addObject(new sandbag(),375,390);
        addObject(new sandbag(),550,470);
        addObject(new sandbag(),550,410);
        addObject(new sandbag(),550,350);
        addObject(new sandbag(),550,290);
        addObject(new sandbag(),550,230);
        addObject(new sandbag(),600,230);
        addObject(new gun(3), 475, 250);
        addObject(new gun(3), 275, 250);
        addObject(new gun(2), 375, 60);
        addObject(new gun(2), 375, 450);
        addObject(new menubutton(),720, 20);
        addObject(new black(), 375, 550);
        addObject(new time_keeper(), 375, 570);
        addObject(new text( "Time","Color.WHITE"), 375, 525);
        addObject(new text("Blue Kills","Color.BLUE"), 150, 525);
        addObject(blue, 150, 570);
        addObject(new text("Red Kills","Color.RED"), 600, 525);
        addObject(red, 600, 570);
    }
    
    public void map2(){
        clearAll();
        map = 2;
        this.addSoldier(P1,100,250);
        this.addSoldier(P2,650,250);
        addObject(new sandbag(),200,250);
        addObject(new sandbag(),200,190);
        addObject(new sandbag(),200,310);
        addObject(new sandbag(),200,130);
        addObject(new sandbag(),200,370);
        addObject(new sandbag(),150,370);
        addObject(new sandbag(),150,130);
        addObject(new sandbag(),550,250);
        addObject(new sandbag(),550,190);
        addObject(new sandbag(),550,130);
        addObject(new sandbag(),550,310);
        addObject(new sandbag(),550,370);
        addObject(new sandbag(),600,370);
        addObject(new sandbag(),600,130);
        addObject(new sandbag(),375,30);
        addObject(new sandbag(),375,90);
        addObject(new sandbag(),375,470);
        addObject(new sandbag(),375,410);
        addObject(new gun(3), 275, 50);
        addObject(new gun(3), 475, 450);
        addObject(new gun(2), 475, 50);
        addObject(new gun(2), 275, 450);
        addObject(new menubutton(),720, 20);
        addObject(new black(), 375, 550);
        addObject(new time_keeper(), 375, 570);
        addObject(new text( "Time","Color.WHITE"), 375, 525);
        addObject(new text("Blue Kills","Color.BLUE"), 150, 525);
        addObject(blue, 150, 570);
        addObject(new text("Red Kills","Color.RED"), 600, 525);
        addObject(red, 600, 570);
    }
    
    public void respawnMap2Weapons()
    {
       addObject(new gun(3), 275, 50);
       addObject(new gun(3), 475, 450);
       addObject(new gun(2), 475, 50);
       addObject(new gun(2), 275, 450);
    }
    
     public void respawnMap1Weapons()
    {
       addObject(new gun(3), 475, 250);
       addObject(new gun(3), 275, 250);
       addObject(new gun(2), 375, 60);
       addObject(new gun(2), 375, 450);
    }
    
    
    /**
     * removes all objects in the game
     */
    public void clearAll()
    {
        removeObjects(getObjects(null));
    }
    
    /**
     * adds a point for the given team
     */
    public void addPoint(int team)
    {
        if(team == 2)
        {
            blue.addScore(1);
        }
        else
        {
            red.addScore(1);
        }
    }
}